<template>
  <div>
    <div
      v-if="!isNew"
      class="row"
    >
      <div class="col-xs-6">
        <ObDatePickerConstructor
          :value="dataSource.eventData && dataSource.eventData.occurredAt"
          label="Дата и время создания"
          :is-time="true"
          :readonly="true"
        />
      </div>
      <div class="col-xs-6">
        <ObInput
          label="Инициатор события"
          :value="dataSource.eventData && dataSource.eventData.authorTitle"
          :readonly="true"
        />
      </div>
    </div>
    <div class="input-row">
      <ObStepper
        v-model="duration.days"
        label="Дней"
        :min-value="0"
        :readonly="!isNew && !isNewForm"
        class="input-duration"
        @input="calcDuration"
      />
      <ObStepper
        v-model="duration.hours"
        label="Часов"
        :min-value="0"
        :readonly="!isNew && !isNewForm"
        class="input-duration"
        @input="calcDuration"
      />
      <ObStepper
        v-model="duration.minutes"
        label="Минут"
        :min-value="0"
        :readonly="!isNew && !isNewForm"
        class="input-duration"
        @input="calcDuration"
      />
      <ObInput
        label="На сумму, без учета НДС"
        :value="formData.specialParameters && formData.specialParameters.amount"
        type="money:2"
        sub-title="₽"
        :readonly="!isNew && !isNewForm"
        placeholder="Введите значение"
        class="input-amount"
        @input="onChangeField('specialParameters.amount', $event)"
      />
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ObTextarea
          :value="formData.eventData && formData.eventData.comment"
          label="Комментарий"
          placeholder="Добавьте комментарий"
          :readonly="!isNew && !isNewForm"
          @input="onChangeField('eventData.comment', $event)"
        />
      </div>
    </div>
    <template v-if="formData.eventData && (!formData.eventData.fileUuids || !formData.eventData.fileUuids.length) && isEditMode && !isNewForm">
      <div class="title">Нет прикрепленных файлов</div>
    </template>
    <template v-if="(formData.eventData && formData.eventData.fileUuids && formData.eventData.fileUuids.length) || isNew || isNewForm">
      <div class="title">Прикрепленные файлы</div>
      <ObUploader
        ref="uploader"
        multiple
        :value="currentFiles"
        data-qa="uploader"
        :is-read-only="(!isNew && !isNewForm)"
        :upload-method="uploadMethod"
        @process-start="startUploadFiles"
        @change="onUploadHandler"
      />
    </template>
  </div>
</template>

<script>
import api from "@/api"
import ObInput from 'common-components/src/obComponents/obInput'
import ObStepper from 'common-components/src/obComponents/obStepper'
import ObTextarea from 'common-components/src/obComponents/obTextarea'
import ObUploader from 'common-components/src/obComponents/obUploader'
import ObDatePickerConstructor from 'common-components/src/obComponents/obDatePickerConstructor'

export default {
  name: 'downtimeEventForm',
  components: {
    ObInput,
    ObTextarea,
    ObUploader,
    ObDatePickerConstructor,
    ObStepper
  },
  props: {
    formData: {
      type: Object,
      default: () => {
        return {
          eventData: {},
          specialParameters: {}
        }
      }
    },
    isEditMode: {
      type: Boolean,
      default: false
    },
    isNew: {
      type: Boolean,
      default: false
    },
    isNewForm: {
      type: Boolean,
      default: false
    },
    dataSource: {
      type: Object,
      default: () => {}
    }
  },
  data () {
    return {
      duration: {
        days: 0,
        hours: 0,
        minutes: 0
      }
    }
  },
  watch: {
    formData: {
      immediate: true,
      handler (data) {
        if (data.specialParameters && data.specialParameters.duration) {
          const duration = data.specialParameters.duration
          const days = Math.floor(duration / (60 * 24))
          const hours = Math.floor((duration - (days * (60 * 24))) / 60)
          const minutes = duration - (days * 60 * 24) - (hours * 60)

          this.duration = {
            days,
            hours,
            minutes
          }
        }
      }
    },
    'formData.eventData.fileUuids'(value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    }
  },
  computed: {
    uploadMethod () {
      return api.files.postFile
    },
    currentFiles () {
      return this.dataSource.filesData
    }
  },
  methods: {
    startUploadFiles () {
      this.formData.eventData.fileUuids = 'loading'
    },
    async onUploadHandler (data) {
      data = data.map(file => file.uuid)

      if (!data || !data.length) {
        this.onChangeField('eventData.fileUuids', null)
        return
      }

      this.onChangeField('eventData.fileUuids', data)
    },
    onChangeField (path, value) {
      this.$emit('change-field', { path, value })
    },
    calcDuration () {
      const { days, hours, minutes } = this.duration
      const duration = +days * 60 * 24 + +hours * 60 + +minutes
      this.onChangeField('specialParameters.duration', duration)
    }
  }
}
</script>

<style lang="scss" scoped>
  .input-row {
    display: flex;
    justify-content: space-between;
  }
  .input-duration {
    width: 100px;
    margin-right: 10px;
  }
  .input-amount {
    flex-grow: 2;
  }
</style>